# GUI de CAPA en TCL TK



proc setHeight {w height} {
    
	global affichage_en_cours

	if {$affichage_en_cours==0} {

		 set affichage_en_cours 1
		 ScilabEval "CAPA_DISPLAY_MAJ('$w');"
		
	}
 
}



 proc SciKAr_validate_key {value} {
	
    if {
		[string is double $value]
	} then {
return 1
    }
    return 0
 }

# Proprits de la fenetre
	set w .scicapa
	catch {destroy $w}
	toplevel $w
	wm title $w "Easy Capa 2.1 \[Merdaillou Customize Version\]"
	wm resizable $w 0 0
	
	frame $w.command
	frame $w.tuning 	

	pack $w.command -side top -anchor w
	pack $w.tuning -side top -anchor w 

	# labelframe $w.command.optim -text "Optimize"
	# labelframe $w.command.switch -text "Switch"
	
	labelframe $w.tuning.cgs -text "Cgs" 
	labelframe $w.tuning.cgd  -text "Cgd" 
	
	# grid $w.command.optim -row 1 -column 1 -ipadx 5 -ipady 5
	# grid $w.command.switch -row 1 -column 2 -ipadx 5 -ipady 5

	
	grid $w.tuning.cgs -row 1 -column 1
	grid $w.tuning.cgd -row 1 -column 2




# =============================================
# Initialisation des variables
# =============================================	

	set affichage_en_cours 0

	##Index
	## set S_index AM0

	##Frequency
	#  set liste_frequency [list 1.5 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 ]
	
# Les valeurs ici sont bidons. Elles sont mise a jour apres par Scilab...
	 set frequency_min 1.5
	 set frequency_max 35

	#Display
	set display_int 0
	set display_S 0
	set display_Y 0
	set display_Z 0

	 set liste_capa [list 	cgs	cgd ]
	 set liste_parameter [list 	C0 			C1 		a 			Vm 			C2 			b 		Vp ]
 	 set liste_value [list 	59.37 		59.57 	6.77 		6.79 		12.58 		25.31 	5.56]
	 set liste_min [list 		10			5		0.1			0.5			2			10		1]
	 set liste_max [list 		90 			95		20			25			50			50		14]

	foreach j $liste_capa {
		foreach i $liste_parameter {
			
			global [set j]_[set i]_value
			global [set j]_[set i]_max
			global [set j]_[set i]_min

			set [set j]_[set i]_value [lindex $liste_value [lsearch $liste_parameter $i]]
			set [set j]_[set i]_max [lindex $liste_max [lsearch $liste_parameter $i]]
			set [set j]_[set i]_min [lindex $liste_min [lsearch $liste_parameter $i]]




		}
	}


# ==============================================
# ==============================================
#	Affichage des optim
# ==============================================
# ==============================================
#	set w .scicapa.command.optim
#	button $w.b -text "Optimize" -width 7 -command {ScilabEval "CAPA_TK_optim(Vgs,Cgs,Vgd,Cgd);"}
#	pack $w.b -side left 

#	set w .scicapa.command.switch
#	button $w.b1 -text "Cgs" -width 7 -command {ScilabEval "CAPA_TK_switch('cgs');"}
#	button $w.b2 -text "Cgd" -width 7 -command {ScilabEval "CAPA_TK_switch('cgd');"}
	
#	pack $w.b1 $w.b2 -side left 




# ==============================================
# ==============================================
#	Affichage des tuness
# ==============================================
# ==============================================

	set w .scicapa.tuning
	
	set liste_name [list 		"C0 (fF)" 	"C1 (fF)" 	"a" 	"Vm (V)" 	"C2 (fF)" 	"b" 	"Vp (V)" ]
	
	foreach j $liste_capa {
		button $w.[set j].b1 -text "Optimize" -width 7 -command "ScilabEval \"CAPA_TK_optim('[set j]');\""
		button $w.[set j].b2 -text "Switch" -width 7 -command "ScilabEval \"CAPA_TK_switch('[set j]');\""
	
		grid $w.[set j].b1 -row 1 -column 1
		grid $w.[set j].b2 -row 1 -column 2
	
	
		foreach i $liste_parameter { 
			label $w.[set j].label_[set i] -text [lindex $liste_name [lsearch $liste_parameter $i]]
			scale $w.[set j].scale_[set i] -orient vertical -width 10 -length 200 -from [set [set j]_[set i]_max] -to [set [set j]_[set i]_min]  -digits 4 -resolution 0.001 -variable [set j]_[set i]_value -command "setHeight [set j]"
			entry $w.[set j].entry_[set i]_max -textvariable [set j]_[set i]_max -width 7 
			entry $w.[set j].entry_[set i]_min -textvariable [set j]_[set i]_min -width 7
			eval "bind \$w.[set j].entry_[set i]_max <Key> \{ if \{\[string equal %K Return\]\} then \{ $w.[set j].scale_[set i] configure -from $[set j]_[set i]_max \}\}"
			eval "bind \$w.[set j].entry_[set i]_min <Key> \{ if \{\[string equal %K Return\]\} then \{ $w.[set j].scale_[set i] configure -to $[set j]_[set i]_min \}\}"
			# eval "bind \$w.[set j].scale_[set i] <ButtonRelease>  \{setHeight [set j]_[set i] \$[set j]_[set i]_value\}" 

			grid $w.[set j].label_$i -row 2 -column [expr [lsearch $liste_parameter $i]+1]
			grid $w.[set j].entry_[set i]_max -row 3 -column [expr [lsearch $liste_parameter $i]+1]
			grid $w.[set j].scale_$i -row 4 -column [expr [lsearch $liste_parameter $i]+1]
			grid $w.[set j].entry_[set i]_min -row 5 -column [expr [lsearch $liste_parameter $i]+1]
		
		
		}
	}
